/*
 * Code and supporting documentation (c) Copyright 1990 1991 Tektronix, Inc.
 * 	All Rights Reserved
 * 
 * This file is a component of an X Window System client which uses the Xcms 
 * Color Management System.  TekColor is a trademark of Tektronix, Inc.  The
 * TekColor Editor is the subject of U.S. and foreign patents pending.  The
 * term "TekHVC" designates a particular color space that is the subject of
 * U.S. Patent No. 4,985,853 (equivalent foreign patents pending).
 * Permission is hereby granted to use, copy, modify, sell, and otherwise
 * distribute this software and its documentation for the X Window System
 * environment, for any purpose and without fee, provided that:
 * 
 * 1.	The code and documentation are only used to implement a 
 *      TekColor Editor in an X Window System environment; and
 * 2.	This copyright and permission notice is reproduced in all copies
 * 	of the code and in supporting documentation.
 * 
 * Permission is granted to modify this code as required to allow it to
 * be compiled on any host computer, provided that the functionality of
 * the TekColor Editor is not modified in any way.  A description of any 
 * modifications must be sent to Tektronix, Inc.  Contact 
 * Tektronix Inc., P.O. Box 1000, Mail Station 60-850, 
 * Network Displays Division Engineering, Wilsonville, OR 97070.
 *
 * Tektronix makes no representation about the suitability of this software
 * for any purpose.  It is provided "as is" and with all faults.
 * 
 * TEKTRONIX DISCLAIMS ALL WARRANTIES APPLICABLE TO THIS SOFTWARE,
 * INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT SHALL TEKTRONIX BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA, OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR THE PERFORMANCE OF THIS SOFTWARE.
 *  
 *	NAME
 *		RepeatBP.h -- definitions for RepeatB.c
 *
 *	DESCRIPTION
 *		
 *
 *	HISTORY
 *
 *	HISTORY END
 *
 */

#ifndef LINT
#ifdef RCS_ID
static char *rcsid=  "$Header: RepeatBP.h,v 1.1 91/08/22 11:21:54 adamsc Exp $";
#endif /* RCS_ID */
#endif /* LINT */

#ifndef _RepeatBP_h
#define _RepeatBP_h

#include "RepeatB.h"
#include <X11/Xaw/SimpleP.h>
#include <X11/Xmu/Converters.h>

typedef struct {
    XtPointer extension;
} RepeaterButtonClassPart;

typedef struct _RepeaterButtonClassRec {
    CoreClassPart			core_class;
    SimpleClassPart			simple_class;
    RepeaterButtonClassPart		repeater_class;
} RepeaterButtonClassRec;

extern RepeaterButtonClassRec repeaterButtonClassRec;

typedef struct {
    /* resources */
    int initial;		    /* initial delay */
    int minimum;		    /* minimum delay */
    int repeat;			    /* subsequent delay */
    int direction;		    /* direction is up, down, left, right */
    Pixel fg_pixel;		    /* foreground color */
    XtCallbackList arm_callbacks;
    XtCallbackList activate_callbacks;
    XtCallbackList disarm_callbacks;

    /* private state */
    int		    next_delay;
    XtIntervalId    timer;
    GC		    localGC;
    Dimension       prefer_width;
    Dimension       prefer_height;
} RepeaterButtonPart;

typedef struct _RepeaterButtonRec {
    CorePart		core;
    SimplePart		simple;
    RepeaterButtonPart	repeater;
} RepeaterButtonRec;

#define REP_DEF_INITIAL_DELAY 250       /* milliseconds */
#define REP_DEF_MINIMUM_DELAY  10
#define REP_DEF_REPEAT_DELAY   50

#endif  /* _RepeatBP_h */
